package com.sprokets.apps;

import java.io.*;
import java.math.*;

import com.sprokets.schemas.invoice.*;

import org.exolab.castor.xml.Unmarshaller;
import org.exolab.castor.xml.ValidationException;
import org.exolab.castor.xml.MarshalException;

public class ReceiveInvoice
{
	public static void main(String[] args)
	{
		try
		{
			// Load 'invoice.xml' XML document into Invoice object
			FileReader reader = new FileReader("invoice.xml");
			Invoice invoice = (Invoice) Unmarshaller.unmarshal(Invoice.class, reader);
			reader.close();
			
			// Dump Invoice
			System.out.println();
			System.out.println("Order: " + invoice.getOrdernumber());
			System.out.println("Rep:   " + invoice.getRep());
			System.out.println();
			System.out.println("Ordered:");
			OrderedBy orderedBy = invoice.getOrderedBy();
			System.out.println("  Customer: " + orderedBy.getCustomerNo());
			System.out.println("  Date:     " + orderedBy.getDate());
			Address orderedByAddress = orderedBy.getAddress();
			System.out.println("  Address:");
			System.out.println("    Street:  " + orderedByAddress.getStreet());
			System.out.println("    City:    " + orderedByAddress.getCity());
			System.out.println("    State:   " + orderedByAddress.getState());
			System.out.println("    Country: " + orderedByAddress.getCountry());			
			System.out.println("    ZIP:     " + orderedByAddress.getZip());			
			Address deliveryAddress = invoice.getDeliveryAddress();
			System.out.println();
			System.out.println("Delivery Address:");
			System.out.println("  Street:  " + deliveryAddress.getStreet());
			System.out.println("  City:    " + deliveryAddress.getCity());
			System.out.println("  State:   " + deliveryAddress.getState());
			System.out.println("  Country: " + deliveryAddress.getCountry());			
			System.out.println("  ZIP:     " + deliveryAddress.getZip());			
			System.out.println();
			System.out.println("Items:");
			InvoiceItems items = invoice.getItems();
			int itemCount = items.getItemCount();
			for(int i=0; i<itemCount; i++)
			{
				InvoiceItem item = items.getItem(i);
				System.out.println();
				System.out.println("  Code:        " + item.getCode());				
				System.out.println("  Description: " + item.getDescription());
				System.out.println("  Quantity:    " + item.getQuantity());
				System.out.println("  Unit Price:  " + item.getUnitPrice());
				System.out.println("  Ext Price:   " + item.getExtPrice());
				System.out.println("  Warehouse:   " + item.getWarehouseLocation());
			}
			System.out.println();
			System.out.println("Net Product:    " + invoice.getNetProduct());
			System.out.println("Postage:        " + invoice.getPostage());
			System.out.println("Total:          " + invoice.getTotalShipment());
			System.out.println("Total Charaged: " + invoice.getAmountCharged());
		}
		catch (IOException e)
		{
			e.printStackTrace(System.out);
		}
		catch (MarshalException e)
		{
			e.printStackTrace(System.out);
		}
		catch (ValidationException e)
		{
			e.printStackTrace(System.out);
		}
	}		
}
					 